---
proxy:
  service:
    type: NodePort
  chp:
    resources:
      requests:
        cpu: 200m
        memory: 512Mi
scheduling:
  userScheduler:
    enabled: false
  userPlaceholder:
    enabled: false

cull:
  timeout: {{ idle_timeout }}

hub:
  image:
    name: {{ jhub_image }}
    tag: {{ jhub_image_tag }}
  db:
    type: sqlite-pvc
    pvc:
      storageClassName: {{ db_storage_class }}

  resources:
    requests:
      cpu: 200m
      memory: 512Mi

  config:
    LTI11Authenticator:
      consumers: {
        "{{ lti_key }}": "{{ lti_secret }}"
        }
      username_key: "lis_person_sourcedid"
    JupyterHub:
      authenticator_class: ltiauthenticator.LTI11Authenticator

      {% if semester_state == "inactive" %}

      template_vars:
        announcement: This JupyterHub is in <i>inactive</i> state. It may be used to access historic data, but not for production. It will eventually be archived and uninstalled.
      {% endif %}
      {% if semester_state == "archived" %}

      template_vars:
        announcement: This JupyterHub is in <i>archived</i> state. It has been temporarely reenabled, and will be shut down again.
      {% endif %}

      {% if semester_state == "active" and announcement | length > 0 -%}
      template_vars:
        announcement: {{ announcement }}
      {% endif %}

  extraConfig:
    myAuthConfig: |
      from ltiauthenticator import LTIAuthenticator
      c.JupyterHub.authenticator_class = LTIAuthenticator

    {% if external_mounts is defined and external_mounts | length > 0 %}

    kubevol: |
        from kubespawner.utils import get_k8s_model
        from kubernetes_asyncio.client.models import ( V1Volume, V1VolumeMount )
        def modify_pod_hook(spawner, pod):
            ext_mounts = {{ external_mounts }}
            try:
                for mnt in ext_mounts:
                            pod.spec.volumes.append(
                                get_k8s_model(V1Volume,
                                 { 'name' : mnt['name'],
                                   'nfs': { 'server' : mnt['server'],
                                            'path' : mnt['path'] }
                                 })
                            )
                            # Note implicitly only 1 container...
                            pod.spec.containers[0].volume_mounts.append(
                              get_k8s_model(V1VolumeMount,
                                  { 'name' : mnt['name'], 'mountPath': mnt['dest'] } )
                            )
            except Exception as e:
                spawner.log.info("Exception in shared-mounts" + str(e))
                pass
            return pod
        c.KubeSpawner.modify_pod_hook = modify_pod_hook
    {% endif %}

prePuller:
  continuous:
    enabled: False
  hook:
    enabled: False
    resources:
      requests:
        cpu: 0
        memory: 0
  resources:
    requests:
      cpu: 0
      memory: 0
ingress:
  enabled: True
  ingressClassName: nginx
  annotations:
    nginx.ingress.kubernetes.io/proxy-body-size: 64m
    cert-manager.io/cluster-issuer: letsencrypt-production
    alias-managed: "true"
  hosts:
    - jhub-{{ cluster }}-{{ moodle_id }}.{{ domain }}
  tls:
    - hosts:
        - jhub-{{ cluster }}-{{ moodle_id }}.{{ domain }}
      secretName: {{ moodle_id }}-tls
singleuser:
  image:
    name: {{ images[0].image }}
    tag: {{ images[0].tag }}

    {% if image_pull_policy is defined %}

    pullPolicy: {{ image_pull_policy }}

    {% endif %}

  lifecycleHooks:
    postStart:
      exec:
        command: ["mkdir", "-p", "assignments"]

  defaultUrl: {{ default_ui }}
  {% if extra_env is defined and extra_env | length > 0 -%}
  extraEnv:
    {% for var in extra_env -%}
    {{ var.name }}: "{{ var.value }}"
    {% endfor %}
    {% endif %}

  memory:
    guarantee: {{ memory_guarantee }}M
    limit: {{ memory_limit }}M

  cpu:
    guarantee: {{ cpu_guarantee }}
    limit: {{ cpu_limit }}

  storage:
    type: static
    capacity: 100Mi
    static:
      pvcName: jhub-{{ cluster }}-{{ moodle_id }}-claim

  profileList:
  {% for notebook in images %}
  - display_name: {{ notebook.display_name }}
    description: {{ notebook.description }}
    kubespawner_override:
        image: {{ notebook.image }}:{{ notebook.tag }}
  {% endfor %}

{% if netpol_blacklist | length > 0 %}
  networkPolicy:
    enabled: true
    egress:
      - to:
        - ipBlock:
            cidr: 0.0.0.0/0
            except:
              - 169.254.169.254/32
              {% for subnet in netpol_blacklist -%}
              - {{ subnet }}
              {% endfor %}
{% endif %}
